﻿using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Grid;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Pdf.Tables;
using System;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace sample
{
    class Program
    {

       static PdfFont gridFont = new PdfStandardFont(PdfFontFamily.Helvetica, 10);
        static void Main(string[] args)
        {
            //Creates a new PDF document.

            PdfDocument pdfDocument = new PdfDocument();

            PdfPage pdfPage = pdfDocument.Pages.Add();
            
            //Creates a new PdfGrid.

            PdfGrid pdfGrid = new PdfGrid();

            pdfGrid.Style.Font = gridFont;


            //Assigns data source.

            DataTable table = TableSource();

            pdfGrid.DataSource = table;

            //Setting the column width based on the maximum width of the contents in respective column
            float column1Width = MeasureWidth(table, 1);


            if(column1Width< pdfPage.GetClientSize().Width) //This condition prevents the table width to  maintain under the page width
            {
                pdfGrid.Columns[1].Width = column1Width;

            }

            float column2Width = MeasureWidth(table, 2); //This condition prevents the table width to  maintain under the page width

            if (column2Width < pdfPage.GetClientSize().Width)
            {
                pdfGrid.Columns[2].Width = column2Width;

            }

            //Draws the grid in to the page of the PDF document.

            pdfGrid.Draw(pdfPage, new PointF(10, 10));

            //Saves the document.

            pdfDocument.Save( "Output.pdf");

            pdfDocument.Close(true);
            Process.Start(Path.Combine( "Output.pdf"));


        }

        public static DataTable TableSource()

        {
            //Creates a DataTable.

            DataTable dataTable = new DataTable();

            //Adds columns to the DataTable.

            dataTable.Columns.Add("ID");

            dataTable.Columns.Add("Name");

            dataTable.Columns.Add("Roll Number");

            //Adds rows to the DataTable.

            for (int i = 0; i < 10; i++)
            {

                dataTable.Rows.Add(new object[] { "EE" + i.ToString(), "Robert", "SS33470976" });

            }

            for (int i = 0; i < 10; i++)
            {

                dataTable.Rows.Add(new object[] { "EE" + i.ToString(), "Tim Cook", "VV45098765323" });
                dataTable.Rows.Add(new object[] { "EE" + i.ToString(), "Albert turring", "WS5609174343 " });
                dataTable.Rows.Add(new object[] { "EE" + i.ToString(), "Rick Harison", "TN33AF4010" });

            }

            return dataTable;
        }

        public static float MeasureWidth(DataTable dataTable, int columnCounnt)
        {
            float maxWidth = 0;

            for (int i=0;i < dataTable.Rows.Count; i++)
            {
                string text = dataTable.Rows[i][columnCounnt] as string;

                float width = gridFont.MeasureString(text).Width;

                if(maxWidth<width)
                maxWidth = width;

            }
            return maxWidth+2;
        }

    }
}
